# coding: utf-8

"""
    GroupDocs.Translation SDK

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 24.11.0
    Contact: anton.perhunov@aspose.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, StrictFloat, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional, Union
from groupdocs_translation_cloud.models.cloud_file_request import CloudFileRequest
from groupdocs_translation_cloud.models.http_status_code import HttpStatusCode
from groupdocs_translation_cloud.models.url_file_info import UrlFileInfo
from typing import Optional, Set
from typing_extensions import Self

class CloudFileResponseWithAdditionalInfo(BaseModel):
    """
    CloudFileResponseWithAdditionalInfo
    """ # noqa: E501
    status: Optional[HttpStatusCode] = None
    message: Optional[StrictStr] = None
    urls: Optional[Dict[str, UrlFileInfo]] = None
    scores: Optional[Dict[str, Optional[Union[StrictFloat, StrictInt]]]] = None
    request: Optional[CloudFileRequest] = None
    details: Optional[Dict[str, Optional[StrictStr]]] = None
    __properties: ClassVar[List[str]] = ["status", "message", "urls", "scores", "request", "details"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of CloudFileResponseWithAdditionalInfo from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each value in urls (dict)
        _field_dict = {}
        if self.urls:
            for _key in self.urls:
                if self.urls[_key]:
                    _field_dict[_key] = self.urls[_key].to_dict()
            _dict['urls'] = _field_dict
        # override the default output from pydantic by calling `to_dict()` of request
        if self.request:
            _dict['request'] = self.request.to_dict()
        # set to None if message (nullable) is None
        # and model_fields_set contains the field
        if self.message is None and "message" in self.model_fields_set:
            _dict['message'] = None

        # set to None if urls (nullable) is None
        # and model_fields_set contains the field
        if self.urls is None and "urls" in self.model_fields_set:
            _dict['urls'] = None

        # set to None if scores (nullable) is None
        # and model_fields_set contains the field
        if self.scores is None and "scores" in self.model_fields_set:
            _dict['scores'] = None

        # set to None if details (nullable) is None
        # and model_fields_set contains the field
        if self.details is None and "details" in self.model_fields_set:
            _dict['details'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of CloudFileResponseWithAdditionalInfo from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "status": obj.get("status"),
            "message": obj.get("message"),
            "urls": dict(
                (_k, UrlFileInfo.from_dict(_v))
                for _k, _v in obj["urls"].items()
            )
            if obj.get("urls") is not None
            else None,
            "scores": obj.get("scores"),
            "request": CloudFileRequest.from_dict(obj["request"]) if obj.get("request") is not None else None,
            "details": obj.get("details")
        })
        return _obj


