# coding: utf-8

"""
    GroupDocs.Translation SDK

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 24.11.0
    Contact: anton.perhunov@aspose.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictBytes, StrictInt, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional, Union
from typing_extensions import Annotated
from typing import Optional, Set
from typing_extensions import Self

class ImageToTextRequest(BaseModel):
    """
    ImageToTextRequest
    """ # noqa: E501
    format: Optional[StrictStr] = Field(default='Unknown', description="Originnal file format")
    source: Optional[Annotated[str, Field(min_length=1, strict=True)]] = Field(default='en', description="Language of original file")
    targets: Optional[List[StrictStr]] = Field(default=None, description="List of target languages")
    file: Optional[Union[StrictBytes, StrictStr]] = Field(default=None, description="File for translation")
    url: Optional[StrictStr] = Field(default=None, description="Link to file for translation")
    rotate: Optional[StrictInt] = Field(default=None, description="Left to write angle to rotate scanned image / pdf")
    ishandwritten: Optional[StrictBool] = Field(default=None, description="is handwritten text")
    origin: Optional[StrictStr] = Field(default=None, description="for analysis only")
    route: Optional[StrictStr] = Field(default=None, description="endpoints route")
    __properties: ClassVar[List[str]] = ["format", "source", "targets", "file", "url", "rotate", "ishandwritten", "origin", "route"]

    @field_validator('format')
    def format_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['Unknown', 'Bmp', 'Jpg', 'Png', 'Svg', 'Gif', 'Pdf']):
            raise ValueError("must be one of enum values ('Unknown', 'Bmp', 'Jpg', 'Png', 'Svg', 'Gif', 'Pdf')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ImageToTextRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # set to None if file (nullable) is None
        # and model_fields_set contains the field
        if self.file is None and "file" in self.model_fields_set:
            _dict['file'] = None

        # set to None if url (nullable) is None
        # and model_fields_set contains the field
        if self.url is None and "url" in self.model_fields_set:
            _dict['url'] = None

        # set to None if origin (nullable) is None
        # and model_fields_set contains the field
        if self.origin is None and "origin" in self.model_fields_set:
            _dict['origin'] = None

        # set to None if route (nullable) is None
        # and model_fields_set contains the field
        if self.route is None and "route" in self.model_fields_set:
            _dict['route'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ImageToTextRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "format": obj.get("format") if obj.get("format") is not None else 'Unknown',
            "source": obj.get("source") if obj.get("source") is not None else 'en',
            "targets": obj.get("targets"),
            "file": obj.get("file"),
            "url": obj.get("url"),
            "rotate": obj.get("rotate"),
            "ishandwritten": obj.get("ishandwritten"),
            "origin": obj.get("origin"),
            "route": obj.get("route")
        })
        return _obj


